from ctypes import *
from os import path


class C_Library(object):
    lib_dir: str = path.dirname(__file__) + '/../lib/'

    def __init__(self, file_name: str, retype: type):
        self.path: str = file_name
        self.lib: _DLLT = cdll.LoadLibrary(
            C_Library.lib_dir + file_name + '.so')
        self.lib.Main.restype = retype

    def Main(self, *args):
        return self.lib.Main(*args)

    def destructor(self):
        self.lib.destructor()
        del self.lib.destructor

    def other(self, name: str, retype: type, *args):
        local_func = getattr(self.lib, name)
        local_func.restype = retype
        return local_func(*args)
